Whamcloud - gitweb
Branch HEAD
[fs/lustre-release.git] / lustrecvs
1 #!/bin/bash
2
3 LC_COLLATE="C"
4 progname="${0##*/}"
5
6 warn ()
7 {
8     [ "$1" ] && echo >&2
9     [ "$1" ] && echo "$progname: $1" >&2
10     [ "$1" ] && echo >&2
11 }
12
13 fatal ()
14 {
15     warn "$2"
16     exit "$1"
17 }
18
19 usage ()
20 {
21     cat <<EOF
22 Usage: $progname <lustretag> <pindate>
23   where <lustretag> is a tag of the lustre-core module
24   and <pindate> is an optional quoted timestamp suitable for cvs -D
25 EOF
26 }
27
28 if [ -z "$LUSTRECVS_UPDATED" ] ; then
29     echo "$progname: updating lustrecvs"
30
31     # If checking out a specific tag, make sure all of the files here are also
32     # checked out with the same tag to avoid later changes breaking things.
33     case "$1" in
34     v*|b_release_*) TAG="-r $1" ;;
35     esac
36
37     cvs update -l $TAG
38     export LUSTRECVS_UPDATED=yes
39     exec "$0" "$@"
40 fi
41
42 [ "$1" = "-r" ] && shift
43
44 buildtag="HEAD"
45 lustretag="$1"
46 shift
47 pindate=$1
48 shift
49
50 if [ "$*" ] ; then
51     usage >&2
52     exit 1
53 fi
54
55 case "$lustretag" in
56     '')
57         warn "a lustretag is required."
58         usage >&2
59         exit 1
60         ;;
61     --help | -h)
62         usage
63         exit 0
64         ;;
65
66     # this is the branch table
67     # keep this list sorted alphabetically!
68
69     # These use special build directories 
70
71     b1_4*) buildtag="b1_4" ;;
72
73     b_release_1_4_6-patchless) buildtag="b1_4" ;;
74     b_release_1_4_7-test) buildtag="b_release_1_4_7" ;;
75
76     b_release*) buildtag=$lustretag ;;
77
78     b_uoss) buildtag=$lustretag ;;
79
80     # These releases did not get build tagged for them because they
81     # this build system didn't exist when they were tagged
82     v1_2_8|v1_4_0) 
83         buildtag="b1_4"
84         ;;
85     
86     v*) buildtag=$lustretag ;;
87
88     # this is the branch table
89     # keep this list sorted alphabetically!
90
91     *)
92         buildtag="HEAD"
93         ;;
94 esac
95
96 error_modules=
97 cvs_cmd ()
98 {
99     dir="$1"
100     module="$2"
101     tag="$3"
102     cotag=""
103     update=""
104
105     if [ "$tag" = "HEAD" ] ; then
106         cotag=""
107         uptag="-A"
108     elif [ "$tag" ] ; then
109         cotag="-r $tag"
110         uptag="-r $tag"
111     else
112         # silently skip if no tag was specified
113         return
114     fi
115
116     # create a cvs date format that will survive shell expansion
117     if [ -n "$pindate" ]; then
118         datecmd=$(date -u +%s -d "$pindate")
119         datecmd="-D @$datecmd"
120     else
121         datecmd=""
122     fi
123
124     if [ -d "$dir" ] ; then
125         echo "$progname: Updating $dir to $tag"
126         ( cd "$dir" && cvs up $datecmd -dAP $uptag )
127     else
128         echo "$progname: Checking out $dir from $tag"
129         cvs co $datecmd -P $cotag -d "$dir" "$module"
130     fi
131     if [ $? != 0 ] ; then
132         error_modules="$dir $error_modules"
133     fi
134 }
135
136 hg_cmd ()
137 {
138     dir="$1"
139     base_url="$2"
140     repository="$3"
141
142     if [ ! "$repository" ]; then
143         return
144     fi
145
146     url="$base_url/$repository"
147
148     # create a cvs date format that will survive shell expansion
149     if [ -n "$pindate" ]; then
150         datecmd=$(date -u +%s -d "$pindate")
151         datecmd="-d \"$datecmd 0\""
152     else
153         datecmd=""
154     fi
155
156     if [ -d "$dir" ]; then
157         echo "$progname: Updating $dir"
158         if [ -f "$dir/update.sh" ]; then
159             ( cd "$dir" && ./update.sh $datecmd )
160         else
161             ( cd "$dir" && hg pull && hg update $datecmd )
162         fi
163     else
164         echo "$progname: Checking out $dir"
165         hg clone $url $dir
166         if [ -f "$dir/setup.sh" ]; then
167             ( cd "$dir" && ./setup.sh $datecmd )
168         else
169             ( cd "$dir" && hg update $datecmd )
170         fi
171     fi
172
173     if [ $? != 0 ] ; then
174         error_modules="$dir $error_modules"
175     fi
176 }
177
178 cvs_cmd build lustre-build "$buildtag"
179
180 if [ -f build/buildcvs ] ; then
181     . build/buildcvs
182 else
183     fatal 1 "build/buildcvs does not exist; not updating other modules."
184 fi
185
186 if [ "$error_modules" ] ; then
187     fatal 1 "There were errors checking out the following directories: $error_modules"
188 fi